﻿	function Errorhandling(error, file, row)
    {
      alert("Error: " + error + "\nFile: " + file + "\nRow: " + row);
    }
	
	var maxOrder = 4;
    var a = new Array(8);
    var x = new Array(8);
    var y = new Array(8);
	var actKnot;
	var knotName;

    function calculate()
    {
      for(var i=0; i < maxOrder; i++)
      {
        a[i] = new Array(maxOrder);
        for(var j=0; j < maxOrder; j++)
        {
          a[i][j] = document.getElementById("A" + (i+1) + (j+1)).value; 
        }
        y[i] = 1.0 * document.getElementById("Y" + (i+1)).value;
        x[i] = 0; 
      }
      try
      {
        if(eliminate())
        {
          solve()
      
          for(var i=0; i < maxOrder; i++)
          {
            for(var j=0; j < maxOrder; j++)
            {
              document.getElementById("A" + (i+1) + (j+1)).value = a[i][j]; 
            }
            document.getElementById("Y" + (i+1)).value = y[i].toFixed(3);
            document.getElementById("X" + (i+1)).value = x[i].toFixed(3);  
          }
        }
        else
          alert("Calculation error in elimination!");
      }
      catch(er)
      {
        alert(er);
      }
	}

   function switchRows(n)
   {
     var tempD;
     var i, j;
     for (i = n; i <= maxOrder - 2; i++)
     {
       tempD = a[i];
       a[i] = a[i + 1]
       a[i + 1] = tempD
       tempD = y[i];
       y[i] = y[i + 1];
       y[i + 1] = tempD;
     }
   }


   function eliminate()
   {
      var i, k, l;
      var calcError = false;

      for (k = 0; k < maxOrder - 1; k++)
      {
        l = k + 1;
        while ((Math.abs(a[k][k]) < 1e-8) && (l < maxOrder))
        {
           switchRows(k);
           l++;
        }
        if (l < maxOrder)
        {
          for (i = k; i <= maxOrder - 2; i++)
          {
            if (!calcError)
            {
              if (Math.abs(a[i + 1][k]) > 1e-8)
              {
                for (l = k + 1; l <= maxOrder - 1; l++)
                {
                  a[i + 1][l] = a[i + 1][l] * a[k][k] - a[k][l] * a[i + 1][k];
                }
                y[i + 1] = y[i + 1] * a[k][k] - y[k] * a[i + 1][k];
                a[i + 1][k] = 0;
              }
            }
          }
        }
        else
          calcError = true;
      }
      return !calcError;
    }


    function solve()
    {
      var k, l;
      for (k = maxOrder - 1; k >= 0; k--)
      {
        for (l = maxOrder - 1; l >= k; l--)
        {
           y[k] = y[k] - x[l] * a[k][l];
        }
        if(Math.abs(a[k][k]) > 1e-8)
          x[k] = y[k] / a[k][k];
        else
          throw "Calculation eror: Division by cero";
      }
    }

    function createMatrix(order, knot)
    {
	  knotName = knot;
	  actKnot = document.getElementById(knot);
      for (var i = 1; i <= order; i++)
      {
        var  tableRow = document.createElement("p");
		actKnot.appendChild(tableRow);
        for (var j = 1; j <= order; j++)
        {
          var field = document.createElement("input");
          field.setAttribute("id","A" + i + j);
		  field.setAttribute("style","width:60px");
          tableRow.appendChild(field);
        }
		var text = document.createTextNode(" = ");
	    tableRow.appendChild(text);
        var res = document.createElement("input");
        res.setAttribute("id","Y" + i);
		res.setAttribute("style","width:60px");
        tableRow.appendChild(res);
     }
     var  tableRow = document.createElement("p");
	 actKnot.appendChild(tableRow);
     for (var i = 1; i <= order; i++)
     {
       var res = document.createElement("input");
       res.setAttribute("id","X" + i);
	   res.setAttribute("style","width:60px");
       tableRow.appendChild(res);
     }
	}
 
	function selectOrder()
	{
		const input = document.getElementById('idOrder');
		maxOrder = input.value;
		a = new Array(maxOrder);
        x = new Array(maxOrder);
        y = new Array(maxOrder);
		for(var i = actKnot.childNodes.length - 1; i >= 0; i--)
		{
		   var el = actKnot.childNodes[i];
		   actKnot.removeChild(el);
		}
		createMatrix(maxOrder, knotName);
	}